variables:
  CONTAINER_IMAGE_BASE_URL: registry.gitlab.com/<%= @full_repo_path %>
  CONTAINER_BUILT_IMAGE: $CONTAINER_IMAGE_BASE_URL:$CI_COMMIT_REF_SLUG
  CONTAINER_BUILDER_IMAGE: $CONTAINER_IMAGE_BASE_URL/builder:$CI_COMMIT_REF_SLUG
  CONTAINER_DEPLOY_IMAGE: $CONTAINER_IMAGE_BASE_URL/deploy:$CI_COMMIT_REF_SLUG
  RELEASE_CONTAINER_BUILT_IMAGE: $CONTAINER_IMAGE_BASE_URL:latest
  RELEASE_CONTAINER_BUILDER_IMAGE: $CONTAINER_IMAGE_BASE_URL/builder:latest
  RELEASE_CONTAINER_DEPLOY_IMAGE: $CONTAINER_IMAGE_BASE_URL/deploy:latest
  DOCKER_DRIVER: overlay
  URL_PRODUCTION: https://<%= @fqdn_production %>
  URL_STAGING: https://<%= @fqdn_staging %>
  URL_REVIEW_SUFFIX: <%= @fqdn_suffix_review %>

stages:
  - build
  - review
  - test
  - staging
  - release
  - production

# Ensure that the site builds {{{
build_image:
  image: docker
  services:
    - docker:dind
  stage: build
  script:
    # Grab the private submodules (public are fine) {{{
    - apk --update add openssh-client git
    - .ci/ssh-init.sh
    - eval $(ssh-agent -s) && echo "$RO_CLONE_PRIVATE_KEY" | ssh-add -
    - git submodule update --init
    # }}}

    - apk --update add ruby-dev ruby-bundler build-base libffi-dev libxml2-dev libxslt-dev
    - bundle install

    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    # pull the latest base image on a master build
    - docker pull $CONTAINER_BUILDER_IMAGE || docker pull $RELEASE_CONTAINER_BUILDER_IMAGE || true
    # Build the builder image {{{
    - bundle exec rake "docker:build[<%= @full_repo_path %>,builder,$CI_COMMIT_REF_SLUG]"
    - docker push $CONTAINER_BUILDER_IMAGE
    # }}}
    # Build the built image {{{
    - docker run -v $(readlink -f .):/app/site $CONTAINER_BUILDER_IMAGE gulp build --production
    - bundle exec rake "docker:build[<%= @full_repo_path %>,built,$CI_COMMIT_REF_SLUG]"
    - docker push $CONTAINER_BUILT_IMAGE
    # }}}
    # Build the deploy image {{{
    - docker pull $CONTAINER_DEPLOY_IMAGE || docker pull $RELEASE_CONTAINER_DEPLOY_IMAGE || true
    - bundle exec rake "docker:build[<%= @full_repo_path %>,deploy,$CI_COMMIT_REF_SLUG]"
    - docker push $CONTAINER_DEPLOY_IMAGE
    # }}}
# }}}

test:
  image: $CONTAINER_BUILDER_IMAGE
  stage: test
  script:
    # Grab the private submodules (public are fine) {{{
    - apk --update add openssh-client git
    - .ci/ssh-init.sh
    - eval $(ssh-agent -s) && echo "$RO_CLONE_PRIVATE_KEY" | ssh-add -
    - git submodule update --init
    # }}}

    - bundle exec rake 'capistrano:validate[<%= @full_repo_path %>,<%= @fqdn_production %>]'
    - bundle exec rake 'gitlab:validate[<%= @full_repo_path %>,<%= @fqdn_production %>]'

# Review Apps {{{
review_deploy:
  image: $CONTAINER_DEPLOY_IMAGE
  stage: review
  script:
    # ensure we're in the directory with our capistrano configuration
    - cd /site
    # ensure that deployments can use the SSH key that is passed in via the
    # environment variables. Via https://docs.gitlab.com/ce/ci/ssh_keys/README.html
    - eval $(ssh-agent -s)
      # add ssh key stored in SSH_PRIVATE_KEY variable to the agent store
    - echo -e "$REVIEW_SSH_PRIVATE_KEY" | ssh-add -
    - cap review deploy
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    url: https://$CI_COMMIT_REF_SLUG.$URL_REVIEW_SUFFIX
    on_stop: review_stop
  only:
    - branches
  variables:
    GIT_STRATEGY: none
  except:
    - master

review_stop:
  image: $CONTAINER_DEPLOY_IMAGE
  stage: review
  script:
    # ensure we're in the directory with our capistrano configuration
    - cd /site
    # ensure that deployments can use the SSH key that is passed in via the
    # environment variables. Via https://docs.gitlab.com/ce/ci/ssh_keys/README.html
    - eval $(ssh-agent -s)
      # add ssh key stored in SSH_PRIVATE_KEY variable to the agent store
    - echo -e "$REVIEW_SSH_PRIVATE_KEY" | ssh-add -
    - cap review stop
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    action: stop
  variables:
    GIT_STRATEGY: none
  when: manual
  only:
    - branches
  except:
    - master
# }}}

# Staging {{{
staging_deploy:
  image: $CONTAINER_DEPLOY_IMAGE
  stage: staging
  script:
    # ensure we're in the directory with our capistrano configuration
    - cd /site
    # ensure that deployments can use the SSH key that is passed in via the
    # environment variables. Via https://docs.gitlab.com/ce/ci/ssh_keys/README.html
    - eval $(ssh-agent -s)
      # add ssh key stored in SSH_PRIVATE_KEY variable to the agent store
    - echo -e "$STAGING_SSH_PRIVATE_KEY" | ssh-add -
    - cap staging deploy
  environment:
    name: staging
    url: $URL_STAGING
  variables:
    GIT_STRATEGY: none
  only:
    - master
# }}}

# Push the images up to the registry as our :latest image, on master {{{
release_builder_image:
  image: docker:1.13
  services:
    - docker:1.13-dind
  stage: release
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull "$CONTAINER_BUILDER_IMAGE"
    - docker tag "$CONTAINER_BUILDER_IMAGE" "$RELEASE_CONTAINER_BUILDER_IMAGE"
    - docker push "$RELEASE_CONTAINER_BUILDER_IMAGE"
  variables:
    GIT_STRATEGY: none
  only:
    - master

release_built_image:
  image: docker:1.13
  services:
    - docker:1.13-dind
  stage: release
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull "$CONTAINER_BUILT_IMAGE"
    - docker tag "$CONTAINER_BUILT_IMAGE" "$RELEASE_CONTAINER_BUILT_IMAGE"
    - docker push "$RELEASE_CONTAINER_BUILT_IMAGE"
  variables:
    GIT_STRATEGY: none
  only:
    - master

release_deploy_image:
  image: docker:1.13
  services:
    - docker:1.13-dind
  stage: release
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull "$CONTAINER_DEPLOY_IMAGE"
    - docker tag "$CONTAINER_DEPLOY_IMAGE" "$RELEASE_CONTAINER_DEPLOY_IMAGE"
    - docker push "$RELEASE_CONTAINER_DEPLOY_IMAGE"
  variables:
    GIT_STRATEGY: none
  only:
    - master
# }}}

# Production {{{
prod_deploy:
  image: $CONTAINER_DEPLOY_IMAGE
  stage: production
  script:
    # ensure we're in the directory with our capistrano configuration
    - cd /site
    # ensure that deployments can use the SSH key that is passed in via the
    # environment variables. Via https://docs.gitlab.com/ce/ci/ssh_keys/README.html
    - eval $(ssh-agent -s)
      # add ssh key stored in SSH_PRIVATE_KEY variable to the agent store
    - echo -e "$PRODUCTION_SSH_PRIVATE_KEY" | ssh-add -
    - cap production deploy
  environment:
    name: production
    url: $URL_PRODUCTION
  variables:
    GIT_STRATEGY: none
  only:
    - master
# }}}
